// ---------------------------------------------------------------------------
// incoming.cs -- Version 2.2 -- October 28, 2000
// by Lorne Laliberte (writer@planetstarsiege.com)
//
// Compose detailed "incoming" warning messages quickly
//
// Concept based in part on the excellent work of DS.Poker and GrymReaper
//
// http://www.writerscripts.com
// ---------------------------------------------------------------------------

include("writer\\version.cs");
version("writer\\incoming.cs", "2.2", "Lorne Laliberte", "Oct 28, 2000");

include("writer\\event.cs");
include("writer\\save.cs");
include("writer\\schedule.cs");
include("writer\\screensize.cs");
include("writer\\whatif.cs");
include("writer\\whud.cs");

// ---------------------------------------------------------------------------
// DEFAULT SETTINGS:
//
// Edit these if you're running this script for the first time
// All subsequent settings must be done in the config\wp_incoming.cs file

    // x and y coordinates for the IncomingHUD interface
    $IncomingHUD::x = "100%";
    $IncomingHUD::y = "50%";

    // Use the Cursor Right key to skip either the bearing or the location step
    // while IncomingHUD is displayed -- does not affect the use of this key
    // while the hud isn't displayed
    $Incoming::useCursorRightForSkip = "false";

    // Use the Page Down key to skip either the bearing or the location step
    // while IncomingHUD is displayed -- does not affect the use of this key
    // while the hud isn't displayed
    $Incoming::usePageDownForSkip = "true";

    // Access the Incoming HUD -- default mode
    //bind(keyboard0, make, "numpad*", to, "Incoming();");

    // Access the Incoming HUD -- alternate mode
    //bind(keyboard0, make, "numlock", to, "Incoming(alternate);");

    // Access the Incoming HUD -- map-specific mode
    //bind(keyboard0, make, "numpad/", to, "Incoming(map);");

    // Access the Incoming HUD -- inbound mode
    //bind(keyboard0, make, "numpad-", to, "Incoming(inbound);");

    // Access the Incoming HUD -- outbound mode
    //bind(keyboard0, make, "numpad+", to, "Incoming(outbound);");

// ---------------------------------------------------------------------------

WriterPrefs::load("incoming");

// See config\incoming_data.cs to change or add mission-specific strings.

$Incoming::rose1 = "southwest";
$Incoming::rose2 = "south";
$Incoming::rose3 = "southeast";
$Incoming::rose4 = "west";
$Incoming::rose6 = "east";
$Incoming::rose7 = "northwest";
$Incoming::rose8 = "north";
$Incoming::rose9 = "northeast";

$Incoming[default, 0, numlock] = "SAME";
$Incoming[default, 1, numlock] = "SAME";

$Incoming[default, 0, slash] = "BACK";
$Incoming[default, 1, slash] = "BACK";

$Incoming[default, 0, star] = "SEND";
$Incoming[default, 1, star] = "SEND";

$Incoming::joinword[default, bearing] = " ";
$Incoming::joinword[default, heading] = " heading ";
$Incoming::joinword[default, location] = " of ";

$Incoming::middle[default, type] = "Type of enemy:";
$Incoming::middle[default, bearing] = "Bearing:";
$Incoming::middle[default, location] = "of:";
$Incoming::middle[default, heading] = "Heading:";

$Incoming::nextStepFrom[default, type] = bearing;
$Incoming::nextStepFrom[default, bearing] = location;
$Incoming::nextStepFrom[default, location] = heading;
$Incoming::nextStepFrom[default, heading] = done;

$Incoming::prevStepFrom[default, type] = type;
$Incoming::prevStepFrom[default, bearing] = type;
$Incoming::prevStepFrom[default, location] = bearing;
$Incoming::prevStepFrom[default, heading] = location;

$Incoming[default, type, decimal] = "Turret\nFarmer";
$Incoming[default, type, 1] = "Light";
$Incoming[default, type, 2] = "Medium";
$Incoming[default, type, 3] = "Heavy";
$Incoming[default, type, 4] = "Sniper";
$Incoming[default, type, 5] = "CANCEL";
$Incoming[default, type, 6] = "Unknown";
$Incoming[default, type, 7] = "Flag\nRunner";
$Incoming[default, type, 8] = "Scout";
$Incoming[default, type, 9] = "APC";

$Incoming[default, plural, decimal] = "Turret\nFarmers";
$Incoming[default, plural, 1] = "Lights";
$Incoming[default, plural, 2] = "Mediums";
$Incoming[default, plural, 3] = "Heavies";
$Incoming[default, plural, 4] = "Snipers";
$Incoming[default, plural, 5] = "CANCEL";
$Incoming[default, plural, 6] = "Unknowns";
$Incoming[default, plural, 7] = "Flag\nRunners";
$Incoming[default, plural, 8] = "Scouts";
$Incoming[default, plural, 9] = "APCs";

$Incoming[default, bearing, 1] = "southwest";
$Incoming[default, bearing, 2] = "south";
$Incoming[default, bearing, 3] = "southeast";
$Incoming[default, bearing, 4] = "west";
$incoming[default, bearing, 5] = "CANCEL";
$Incoming[default, bearing, 6] = "east";
$Incoming[default, bearing, 7] = "northwest";
$Incoming[default, bearing, 8] = "north";
$Incoming[default, bearing, 9] = "northeast";

$Incoming[default, location, decimal] = "sensor";
$Incoming[default, location, 1] = "front door";
$Incoming[default, location, 2] = "tower";
$Incoming[default, location, 3] = "objective";
$Incoming[default, location, 4] = "generator";
$Incoming[default, location, 5] = "CANCEL";
$Incoming[default, location, 6] = "turret";
$Incoming[default, location, 7] = "flag";
$Incoming[default, location, 8] = "base";
$Incoming[default, location, 9] = "roof";

$Incoming[default, owner, 0, decimal] = "our\n";
$Incoming[default, owner, 0, 1] = "our\n";
$Incoming[default, owner, 0, 2] = "our\n";
$Incoming[default, owner, 0, 3] = "";
$Incoming[default, owner, 0, 4] = "our\n";
$Incoming[default, owner, 0, 5] = "";
$Incoming[default, owner, 0, 6] = "our\n";
$Incoming[default, owner, 0, 7] = "our\n";
$Incoming[default, owner, 0, 8] = "our\n";
$Incoming[default, owner, 0, 9] = "our\n";

$Incoming[default, owner, 1, decimal] = "enemy\n";
$Incoming[default, owner, 1, 1] = "enemy\n";
$Incoming[default, owner, 1, 2] = "enemy\n";
$Incoming[default, owner, 1, 3] = "";
$Incoming[default, owner, 1, 4] = "enemy\n";
$Incoming[default, owner, 1, 5] = "";
$Incoming[default, owner, 1, 6] = "enemy\n";
$Incoming[default, owner, 1, 7] = "enemy\n";
$Incoming[default, owner, 1, 8] = "enemy\n";
$Incoming[default, owner, 1, 9] = "enemy\n";

$incoming[default, heading, 1] = "southwest";
$incoming[default, heading, 2] = "south";
$incoming[default, heading, 3] = "southeast";
$incoming[default, heading, 4] = "west";
$Incoming[default, heading, 5] = "CANCEL";
$incoming[default, heading, 6] = "east";
$incoming[default, heading, 7] = "northwest";
$incoming[default, heading, 8] = "north";
$incoming[default, heading, 9] = "northeast";


$Incoming::joinword[alternate, location] = " ";

$Incoming::middle[alternate, location] = "Location:";

$Incoming::nextStepFrom[alternate, type] = location;
$Incoming::nextStepFrom[alternate, location] = done;

$Incoming::prevStepFrom[alternate, type] = type;
$Incoming::prevStepFrom[alternate, location] = type;

$Incoming[alternate, type, decimal] = "Turret\nFarmer";
$Incoming[alternate, type, 1] = "Light";
$Incoming[alternate, type, 2] = "Medium";
$Incoming[alternate, type, 3] = "Heavy";
$Incoming[alternate, type, 4] = "Sniper";
$Incoming[alternate, type, 5] = "CANCEL";
$Incoming[alternate, type, 6] = "Unknown";
$Incoming[alternate, type, 7] = "Flag\nRunner";
$Incoming[alternate, type, 8] = "Scout";
$Incoming[alternate, type, 9] = "APC";

$Incoming[alternate, plural, decimal] = "Turret\nFarmers";
$Incoming[alternate, plural, 1] = "Lights";
$Incoming[alternate, plural, 2] = "Mediums";
$Incoming[alternate, plural, 3] = "Heavies";
$Incoming[alternate, plural, 4] = "Snipers";
$Incoming[alternate, plural, 5] = "CANCEL";
$Incoming[alternate, plural, 6] = "Unknowns";
$Incoming[alternate, plural, 7] = "Flag\nRunners";
$Incoming[alternate, plural, 8] = "Scouts";
$Incoming[alternate, plural, 9] = "APCs";

$Incoming[alternate, owner, 0, decimal] = "at our\n";
$Incoming[alternate, owner, 0, 1] = "at our\n";
$Incoming[alternate, owner, 0, 2] = "at\n";
$Incoming[alternate, owner, 0, 3] = "at\n";
$Incoming[alternate, owner, 0, 4] = "attacking\n";
$Incoming[alternate, owner, 0, 5] = "";
$Incoming[alternate, owner, 0, 6] = "attacking\n";
$Incoming[alternate, owner, 0, 7] = "attacking\n";
$Incoming[alternate, owner, 0, 8] = "attacking\n";
$Incoming[alternate, owner, 0, 9] = "on our\n";

$Incoming[alternate, owner, 1, decimal] = "at enemy\n";
$Incoming[alternate, owner, 1, 1] = "at enemy\n";
$Incoming[alternate, owner, 1, 2] = "at\n";
$Incoming[alternate, owner, 1, 3] = "at\n";
$Incoming[alternate, owner, 1, 4] = "defending\n";
$Incoming[alternate, owner, 1, 5] = "";
$Incoming[alternate, owner, 1, 6] = "defending\n";
$Incoming[alternate, owner, 1, 7] = "defending\n";
$Incoming[alternate, owner, 1, 8] = "defending\n";
$Incoming[alternate, owner, 1, 9] = "on enemy\n";

$Incoming[alternate, location, decimal] = "sensor";
$Incoming[alternate, location, 1] = "front door";
$Incoming[alternate, location, 2] = "tower";
$Incoming[alternate, location, 3] = "objective";
$Incoming[alternate, location, 4] = "generator";
$incoming[alternate, location, 5] = "CANCEL";
$Incoming[alternate, location, 6] = "turret";
$Incoming[alternate, location, 7] = "flag";
$Incoming[alternate, location, 8] = "base";
$Incoming[alternate, location, 9] = "roof";


$Incoming::nextStepFrom[inbound, bearing] = done;
$Incoming::prevStepFrom[inbound, bearing] = bearing;

$incoming[inbound, type, 1] = "Inbound, ";

$incoming[inbound, plural, 1] = "Inbound, ";

$Incoming::type[inbound] = 1;

$incoming[inbound, bearing, 1] = "southwest";
$incoming[inbound, bearing, 2] = "south";
$incoming[inbound, bearing, 3] = "southeast";
$incoming[inbound, bearing, 4] = "west";
$Incoming[inbound, bearing, 5] = "CANCEL";
$incoming[inbound, bearing, 6] = "east";
$incoming[inbound, bearing, 7] = "northwest";
$incoming[inbound, bearing, 8] = "north";
$incoming[inbound, bearing, 9] = "northeast";


$Incoming::nextStepFrom[outbound, bearing] = done;
$Incoming::prevStepFrom[outbound, bearing] = bearing;

$incoming[outbound, type, 1] = "Outbound, ";

$incoming[outbound, plural, 1] = "Outbound, ";

$Incoming::type[outbound] = 1;

$incoming[outbound, bearing, 1] = "southwest";
$incoming[outbound, bearing, 2] = "south";
$incoming[outbound, bearing, 3] = "southeast";
$incoming[outbound, bearing, 4] = "west";
$Incoming[outbound, bearing, 5] = "CANCEL";
$incoming[outbound, bearing, 6] = "east";
$incoming[outbound, bearing, 7] = "northwest";
$incoming[outbound, bearing, 8] = "north";
$incoming[outbound, bearing, 9] = "northeast";


$Incoming::sound[default] = "~wincom2";   // Incoming enemies!
$Incoming::sound[inbound] = "~wincom2";   // Incoming enemies!
$Incoming::sound[outbound] = "~wtgtobj";  // Target location.
$Incoming::sound[alternate] = "~wincom2"; // Incoming enemies!

$Incoming::sound[default, 1] = "~wtgtobj"; // Target location.

$Incoming::sound[alternate, location, 0, 1] = "~wbasundr"; // The enemy is attacking our base!
$Incoming::sound[alternate, location, 0, 2] = "~wdefobj";  // Defend the objective.
$Incoming::sound[alternate, location, 0, 3] = "~wdefobj";  // Defend the objective.
//$Incoming::sound[alternate, location, 0, 4] = "~wbasetkn"; // Our base has been taken!
$Incoming::sound[alternate, location, 0, 4] = "~wbasundr"; // The enemy is attacking our base!
$Incoming::sound[alternate, location, 0, 6] = "~wbasatt";  // We're being attacked!
$Incoming::sound[alternate, location, 0, 7] = "~wbasatt";  // We're being attacked!
$Incoming::sound[alternate, location, 0, 8] = "~wbasundr"; // The enemy is attacking our base!
$Incoming::sound[alternate, location, 0, 9] = "~wbasundr"; // The enemy is attacking our base!

$Incoming::sound[alternate, 1] = "~wtgtobj"; // Target location.

$Incoming::mode = default;
$Incoming::owner = 0;
$Incoming::currentNorth = 8;

// Determine whether to use the plural form of the type string
function Incoming::pluralize(%step)
{
    if(%step != type)
        return %step;

    if($Incoming::ShowPrevious)
    {
        if($Incoming::previousNumber == 1)
            return type;
        else
            return plural;
    }
    else
    {
        if($Incoming::number == 1)
            return type;
        else
            return plural;
    }
}


// Build the text for the specific step and key
function Incoming::text(%step, %n)
{
    %plural = Incoming::pluralize(%step);

    %text = $Incoming[$Incoming::mode, %plural, %n];

    if(%text == "")
    {
        if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
            %text = $Incoming[alternate, %plural, %n];
        else
            %text = $Incoming[alternate, %plural, %n];
    }
    return %text;
}


// Increase number of incoming/outgoing by 1
function Incoming::more()
{
    if($Incoming::ShowPrevious)
    {
        $Incoming::previousNumber++;

        if($Incoming::previousNumber > 4)
            $Incoming::previousNumber = 5; // make 5 the maximum

        $Incoming::number = $Incoming::previousNumber;
    }
    else
    {
        $Incoming::number++;

        if($Incoming::number > 4)
            $Incoming::number = 5; // make 5 the maximum
    }

    $Incoming::text[type] = Incoming::text(type, $Incoming::type[$Incoming::mode]);

    Incoming::show($Incoming::step);
}


// Decrease number of incoming/outgoing by 1
function Incoming::less()
{
    if($Incoming::ShowPrevious)
    {
        $Incoming::previousNumber--;

        if($Incoming::previousNumber < 1)
            $Incoming::previousNumber = 1; // make 1 the minimum

        $Incoming::number = $Incoming::previousNumber;
    }
    else
    {
        $Incoming::number--;

        if($Incoming::number < 1)
            $Incoming::number = 1; // make 1 the minimum
    }

    $Incoming::text[type] = Incoming::text(type, $Incoming::type[$Incoming::mode]);

    Incoming::show($Incoming::step);
}


function Incoming::setNumber(%number)
{
    if($Incoming::ShowPrevious)
        $Incoming::previousNumber = %number;

    $Incoming::number = %number;

    Incoming::updateHeader();
}


function Incoming::resetOwner()
{
//    $Incoming::owner[$Incoming::mode] = $Incoming::previousOwner[$Incoming::mode];
//    if($Incoming::owner[$Incoming::mode] == "")
//        $Incoming::owner[$Incoming::mode] = 0;
    $Incoming::owner[$Incoming::mode] = 0;
}

function Incoming::resetNumber()
{
    $Incoming::number = 1;
    $Incoming::previousNumber = $Incoming::previousNumber[$Incoming::mode];
    if($Incoming::previousNumber == "")
        $Incoming::previousNumber = 1;
}


function Incoming::setNorth(%n)
{
    if(%n == $Incoming::currentNorth)
        return;

    //          01234567
    %bouquet = "47896321";

    %offset = String::findSubStr(%bouquet, %n) - 2;

    if(%offset < 0)
        %offset = 8 + %offset; // rollover from left to right

    for(%i = 1; %i <= 9; %i++)
    {
        if(%i == 5)
            continue;

        %pos = String::findSubStr(%bouquet, %i);
        %pos += %offset;

        if(%pos > 7)
            %pos = %pos - 8; // rollover from right to left

        %newn = String::getSubStr(%bouquet, %pos, 1);

        $Incoming[default, bearing, %i] = $Incoming::rose[%newn];
        $Incoming[default, heading, %i] = $Incoming::rose[%newn];
        $Incoming[alternate, bearing, %i] = $Incoming::rose[%newn];
        $Incoming[inbound, bearing, %i] = $Incoming::rose[%newn];
        $Incoming[outbound, bearing, %i] = $Incoming::rose[%newn];

        // Only change map-specific data if it exists
        if($Incoming[$Incoming::map, bearing, %i] != "")
            $Incoming[$Incoming::map, bearing, %i] = $Incoming::rose[%newn];
    }
    $Incoming::currentNorth = %n;
    $Incoming::nextStep = $Incoming::step;
    Incoming::show($Incoming::step);
}


// Reset directions (call this on map change)
function Incoming::resetNorth()
{
    if($Incoming::currentNorth == 8)
        return;

    for(%i = 1; %i <= 9; %i++)
    {
        if(%i == 5)
            continue;

        $Incoming[default, bearing, %i] = $Incoming::rose[%i];
        $Incoming[default, heading, %i] = $Incoming::rose[%i];
        $Incoming[alternate, bearing, %i] = $Incoming::rose[%i];
        $Incoming[inbound, bearing, %i] = $Incoming::rose[%i];
        $Incoming[outbound, bearing, %i] = $Incoming::rose[%i];

        // Only change map-specific data if it exists
        if($Incoming[$Incoming::map, bearing, %i] != "")
            $Incoming[$Incoming::map, bearing, %i] = $Incoming::rose[%i];
    }
    $Incoming::currentNorth = 8;
}


// Main access into Incoming
function Incoming(%n)
{
    if(%n == "")
    {
        pushActionMap("IncomingMap.sae");

        Incoming::cleartext();

        $Incoming::mode = default;
        $Incoming::ShowPrevious = true;

        Incoming::resetOwner();
        Incoming::resetNumber();

        $Incoming::step = $Incoming::nextStep = type;
        Incoming::show($Incoming::step);
        return;
    }
    else if(%n == abort)
    {
        return;
    }
    else if(%n == alternate)
    {
        pushActionMap("IncomingMap.sae");

        Incoming::cleartext();

        $Incoming::mode = alternate;
        $Incoming::ShowPrevious = true;

        Incoming::resetOwner();
        Incoming::resetNumber();

        $Incoming::step = $Incoming::nextStep = type;
        Incoming::show($Incoming::step);
        return;
    }
    else if(%n == map)
    {
        pushActionMap("IncomingMap.sae");

        Incoming::cleartext();

        $Incoming::mode = $Incoming::map;
        $Incoming::ShowPrevious = true;

        Incoming::resetOwner();
        Incoming::resetNumber();

        $Incoming::step = $Incoming::nextStep = type;

        Incoming::show($Incoming::step);
        return;
    }
    else if(%n == inbound)
    {
        pushActionMap("IncomingMap.sae");

        Incoming::cleartext();

        $Incoming::mode = inbound;
        $Incoming::text[type] = "Inbound, ";
        $Incoming::ShowPrevious = true;

        Incoming::resetOwner();
        Incoming::resetNumber();

        $Incoming::step = $Incoming::nextStep = bearing;
        Incoming::updateHeader();

        Incoming::show($Incoming::step);
        return;
    }
    else if(%n == outbound)
    {
        pushActionMap("IncomingMap.sae");

        Incoming::cleartext();

        $Incoming::mode = outbound;
        $Incoming::text[type] = "Outbound, ";
        $Incoming::ShowPrevious = true;

        Incoming::resetOwner();
        Incoming::resetNumber();

        $Incoming::step = $Incoming::nextStep = bearing;
        Incoming::updateHeader();

        Incoming::show($Incoming::step);
        return;
    }
    else if(%n == slash) // go back
    {
        Incoming::cancelBlink();

        if(($Incoming::mode == inbound) || ($Incoming::mode == outbound))
            return;

        $Incoming::nextStep = Incoming::prevStep();

        $Incoming::text[$Incoming::nextStep] = "";

        if($Incoming::nextStep == type)
        {
            $Incoming::type[$Incoming::mode] = "";
        }

        if($Incoming::step == type)
        {
            // reset the message to the original previous message
            // (undo any changes to the previous message), except
            // for any changes made to the number of enemies
            $Incoming::ShowPrevious = true;
            Incoming::resetOwner();
            $Incoming::location = $Incoming::previousLocation[$Incoming::mode];
            $Incoming::type[$Incoming::mode] = $Incoming::previousType[$Incoming::mode];
        }
    }
    else if(%n == numlock) // go forward
    {
        Incoming::cancelBlink();

        $Incoming::text[$Incoming::step] = $Incoming::previousText[$Incoming::mode, $Incoming::step];

        if($Incoming::step == type)
            $Incoming::type[$Incoming::mode] = $Incoming::previousType[$Incoming::mode];

        Incoming::updateHeader();

        if($Incoming::step == type)
        {
            if(($Incoming::text[$Incoming::step] == "") || ($Incoming::type[$Incoming::mode] == ""))
                return;

            $Incoming::ShowPrevious = false;
            $Incoming::nextStep = Incoming::nextStep();
        }
        else
        {
            // Protect against mode changes
            if($Incoming::text[$Incoming::step] == "")
                return;

            $Incoming::ShowPrevious = false;
            $Incoming::nextStep = Incoming::nextStep();
        }
    }
    else if(%n == star) // done
    {
        Incoming::cancelBlink();
        $Incoming::nextStep = done;
    }
    else if(%n == number) // use previous number of incoming
    {
        Incoming::cancelBlink();
        $Incoming::number = $Incoming::previousNumber;
        $Incoming::nextStep = $Incoming::step;

        Incoming::updateHeader();
        return;
    }
    else if(%n == 5)
    {
        $Incoming::nextStep = "cancel";
    }
    else if(%n == owner) // change owner
    {
        $Incoming::owner[$Incoming::mode] = !$Incoming::owner[$Incoming::mode];

        $Incoming::nextStep = $Incoming::step;
        Incoming::show($Incoming::step);
        return;
    }
    else if(%n == skip) // skip step
    {
        Incoming::cancelBlink();

        if($Incoming::mode != default)
            return;

        %nextStep = Incoming::nextStep();

        if(%nextStep == done)
            return;

        if(%nextStep == bearing)
            return;

        if(%nextStep == location)
            %nextStep = heading;

        $Incoming::ShowPrevious = false;

        Incoming::show($Incoming::nextStep = %nextStep);
        return;
    }
    else // a number key or the decimal key
    {
        Incoming::cancelBlink();
        $Incoming::ShowPrevious = false;

        if($Incoming::step == type)
            $Incoming::type[$Incoming::mode] = %n;

        // disable decimal key on all but type and location
        if(%n == decimal)
        {
            if(!(($Incoming::step == type) || ($Incoming::step == location)))
                return;
        }

        if(($Incoming::step == location) && (%n != numlock))
            $Incoming::location = %n;

        $Incoming::text[$Incoming::step] = Incoming::text($Incoming::step, %n);

        $Incoming::nextStep = Incoming::nextStep();
        Incoming::show($Incoming::step);
    }

    // Remember what key was pressed
    $Incoming::n = %n;
    Incoming::blink(%n);
}


function Incoming::blink(%n)
{
    $Incoming::blink[%n] = !$Incoming::blink[%n];

    %showkey = true;
    %highlight = true;

    if(%n == numlock || %n == slash || %n == star)
        %showkey = %highlight = false;

    if(%n == 5)
        %highlight = false;

    if($Incoming::blink[%n])
        Control::setValue("IncomingHUD" @ %n, "<jc><f2>" @ wif(%showkey, %n, "") @ "\n" @ Incoming::cell($Incoming::step, %n));
    else
        Control::setValue("IncomingHUD" @ %n, "<jc>" @ wif(%showkey, %n, "") @ "\n" @ wif(%highlight, "<f1>", "<f0>") @ Incoming::cell($Incoming::step, %n));

    if($Incoming::blinkcount[%n]++ < 7)
    {
        schedule::add("Incoming::blink(" @ %n @ ");", 0.05, incoming::blink);
    }
    else
    {
        $Incoming::blink[%n] = false;
        $Incoming::blinkcount[%n] = 0;

        $Incoming::step = $Incoming::nextStep;
        if($Incoming::step != abort)
            Incoming::show($Incoming::step);
    }
}


function Incoming::cancelBlink()
{
    schedule::cancel("incoming::blink");

    $Incoming::blink[$Incoming::n] = false;
    $Incoming::blinkcount[$Incoming::n] = 0;

    %showkey = true;
    %highlight = true;

    if($Incoming::n == numlock || $Incoming::n == slash || $Incoming::n == star)
        %showkey = %highlight = false;

    if($Incoming::n == 5)
        %highlight = false;


    Control::setValue("IncomingHUD" @ $Incoming::n, "<jc>" @ wif(%showkey, $Incoming::n, "") @ "\n" @ wif(%highlight, "<f1>", "<f0>") @ Incoming::cell($Incoming::step, $Incoming::n));
    $Incoming::step = $Incoming::nextStep;
}


// Determine what to join the step strings with
//
function Incoming::joinword(%step, %prev)
{
    %text = $Incoming::joinword[$Incoming::mode, %step];

    if(%text == "")
    {
        if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
            %text = $Incoming::joinword[alternate, %step];
        else
            %text = $Incoming::joinword[default, %step];
    }

    if(%prev)
    {
        if($Incoming::previousText[$Incoming::mode, %step] == "")
            return "";

        return %text;
    }

    if($Incoming::text[%step] == "")
        return "";

    return %text;
}


// Figure out what sound to use
//
function Incoming::sound(%prev)
{
    if(%prev)
    {
        %location = $Incoming::previousLocation[$Incoming::mode];
        %test = ($Incoming::previousText[$Incoming::mode, location] != "");
    }
    else
    {
        %location = $Incoming::location;
        %test = ($Incoming::text[location] != "");
    }

    if(%test) // we made it to (or past) the location step
    {
        // Check for mode + location + owner specific sound
        if((%sound = $Incoming::sound[$Incoming::mode, location, $Incoming::owner[$Incoming::mode], %location]) != "")
            return %sound;

        if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
        {
            // Check for alternate mode + location + owner specific sound
            if((%sound = $Incoming::sound[alternate, location, $Incoming::owner[$Incoming::mode], %location]) != "")
                return %sound;
        }
        else
        {
            // Check for default mode + location + owner specific sound
            if((%sound = $Incoming::sound[default, location, $Incoming::owner[$Incoming::mode], %location]) != "")
                return %sound;
        }
    }

    // Check for mode + owner specific sound
    if((%sound = $Incoming::sound[$Incoming::mode, $Incoming::owner[$Incoming::mode]]) != "")
        return %sound;

    if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
    {
        // Check for alternate mode + owner specific sound
        if((%sound = $Incoming::sound[alternate, $Incoming::owner[$Incoming::mode]]) != "")
            return %sound;
    }
    else
    {
        // Check for default mode + owner specific sound
        if((%sound = $Incoming::sound[default, $Incoming::owner[$Incoming::mode]]) != "")
            return %sound;
    }

    if(%prev)
    {
        %type = $Incoming::previousType[$Incoming::mode];
        %test = ($Incoming::previousText[$Incoming::mode, location] != "");
    }
    else
    {
        %type = $Incoming::type[$Incoming::mode];
        %test = ($Incoming::text[location] != "");
    }

    if(%test) // we made it to (or past) the type step
    {
        // Check for mode + step + type specific sound
        if((%sound = $Incoming::sound[$Incoming::mode, $Incoming::step, %type]) != "")
            return %sound;

        if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
        {
            // Check for alternate mode + step + type specific sound
            if((%sound = $Incoming::sound[alternate, $Incoming::step, %type]) != "")
                return %sound;
        }
        else
        {
            // Check for default mode + step + type specific sound
            if((%sound = $Incoming::sound[default, $Incoming::step, %type]) != "")
                return %sound;
        }
    }

    // Check for mode + step specific sound
    if((%sound = $Incoming::sound[$Incoming::mode, $Incoming::step]) != "")
        return %sound;

    if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
    {
        // Check for alternate mode + step specific sound
        if((%sound = $Incoming::sound[alternate, $Incoming::step]) != "")
            return %sound;
    }
    else
    {
        // Check for default mode + step specific sound
        if((%sound = $Incoming::sound[default, $Incoming::step]) != "")
            return %sound;
    }

    // Check for mode specific sound
    if((%sound = $Incoming::sound[$Incoming::mode]) != "")
        return %sound;

    if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
    {
        // Check for alternate mode specific sound
        if((%sound = $Incoming::sound[alternate]) != "")
            return %sound;
    }

    // Use default sound
    return $Incoming::sound[default];
}


// Update the header without updating the rest of the hud
function Incoming::updateHeader()
{
    // Update the message
    if($Incoming::ShowPrevious)
        $Incoming::text = Incoming::previousMsg();
    else
        $Incoming::text = Incoming::msg();

    Control::setValue("IncomingHEADER", "<jc><f2> " @ $Incoming::text);
}


// Translate any carriage returns into spaces
function Incoming::convertNewlines(%string)
{
    while((%pos = String::findSubStr(%string, "\n")) != -1)
    {
        %t1 = String::getSubStr(%string, 0, %pos);
        %t2 = String::getSubStr(%string, %pos + 1, 1024);
        %string = %t1 @ " " @ %t2;
    }
    return %string;
}


// Rebuild $Incoming::text using current values
function Incoming::msg()
{
    if($Incoming::number == 1)
        %text = "";
    else if($Incoming::number == 5)
        %text = "Lots of ";
    else
        %text = $Incoming::number @ " ";

    %text = %text @ Incoming::text(type, $Incoming::type[$Incoming::mode])
                  @ Incoming::joinword(bearing)
                  @ $Incoming::text[bearing]
                  @ Incoming::joinword(location)
                  @ Incoming::owner($Incoming::text[location])
                  @ $Incoming::text[location]
                  @ Incoming::joinword(heading)
                  @ $Incoming::text[heading];

    return $Incoming::text = Incoming::convertNewlines(%text);
}


// Rebuild $Incoming::text using previous values
function Incoming::previousMsg()
{
    if($Incoming::previousNumber == 1)
        %text = "";
    else if($Incoming::previousNumber == 5)
        %text = "Lots of ";
    else
        %text = $Incoming::previousNumber @ " ";

    %text = %text @ Incoming::text(type, $Incoming::previousType[$Incoming::mode])
                  @ Incoming::joinword(bearing, 1)
                  @ $Incoming::previousText[$Incoming::mode, bearing]
                  @ Incoming::joinword(location, 1)
                  @ Incoming::owner($Incoming::previousText[$Incoming::mode, location])
                  @ $Incoming::previousText[$Incoming::mode, location]
                  @ Incoming::joinword(heading, 1)
                  @ $Incoming::previousText[$Incoming::mode, heading];

    return $Incoming::text = Incoming::convertNewlines(%text);
}


function Incoming::show(%step)
{
    if(%step == done)
    {
        popActionMap("IncomingMap.sae");
        Incoming::hide();
        $Incoming::step = ""; // set to abort instead?

        if($Incoming::ShowPrevious)
        {
            // We're still showing the previous message

            // Update the owner and number, which are the only parts of the
            // previous message we might have changed
            $Incoming::previousOwner[$Incoming::mode] = $Incoming::owner[$Incoming::mode];
            $Incoming::previousNumber[$Incoming::mode] = $Incoming::number;

            // Prepare the previous message
            %msg = Incoming::previousMsg();
            if((%msg == "") || (%msg == " "))
                return;

            // Broadcast the message
            say(1, %msg @ Incoming::sound(true));
            return;
        }
        else
        {
            // We built a new message

            // Update all the previous message stuff
            $Incoming::previousOwner[$Incoming::mode] = $Incoming::owner[$Incoming::mode];
            $Incoming::previousNumber[$Incoming::mode] = $Incoming::number;
            $Incoming::previousType[$Incoming::mode] = $Incoming::type[$Incoming::mode];
            $Incoming::previousLocation[$Incoming::mode] = $Incoming::location;
            $Incoming::previousText[$Incoming::mode, type] = $Incoming::text[type];
            $Incoming::previousText[$Incoming::mode, bearing] = $Incoming::text[bearing];
            $Incoming::previousText[$Incoming::mode, location] = $Incoming::text[location];
            $Incoming::previousText[$Incoming::mode, heading] = $Incoming::text[heading];

            // Prepare the new message
            %msg = Incoming::msg();
            if((%msg == "") || (%msg == " "))
                return;

            // Broadcast the message
            say(1, %msg @ Incoming::sound());
            return;
        }
    }

    if(%step == "cancel")
    {
        popActionMap("IncomingMap.sae");
        Incoming::hide();
        $Incoming::step = "";
        return;
    }

    Control::setVisible(IncomingFRAME, true);
    Control::setVisible(IncomingHEADERF, true);
    Control::setVisible(IncomingHEADER, true);

    Control::setVisible(IncomingMIDDLEF, true);
    Control::setVisible(IncomingMIDDLE, true);

    %text = $Incoming::middle[$Incoming::mode, %step];

    if(%text == "")
    {
        if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
            %text = $Incoming::middle[alternate, %step];
        else
            %text = $Incoming::middle[default, %step];
    }

    Control::setValue("IncomingMIDDLE", "<jc><f0>" @ %text);

    // Update the message
    if($Incoming::ShowPrevious)
        $Incoming::text = Incoming::previousMsg();
    else
        $Incoming::text = Incoming::msg();

    Control::setValue("IncomingHEADER", "<jc><f2> " @ $Incoming::text);

    Control::setVisible(IncomingHUDnumlock, true);
    Control::setVisible(IncomingHUDslash, true);
    Control::setVisible(IncomingHUDstar, true);

    Control::setValue(IncomingHUDnumlock, "<jc>\n<f0>" @ Incoming::cell(%step, numlock));
    Control::setValue(IncomingHUDslash, "<jc>\n<f0>" @ Incoming::cell(%step, slash));
    Control::setValue(IncomingHUDstar, "<jc>\n<f0>" @ Incoming::cell(%step, star));


    for(%n = 1; %n < 10; %n++)
    {
        Control::setVisible("IncomingHUD" @ %n, true);
        Control::setValue("IncomingHUD" @ %n, "<jc>" @ %n @ "\n" @ wif(%n == 5, "<f0>", "<f1>") @ Incoming::cell(%step, %n));
    }
}


// Determine the ownership string (our/enemy, attacking/defending, etc.)
function Incoming::owner(%text)
{
    if(%text == "")
        return;

    %owner = $Incoming[$Incoming::mode, owner, $Incoming::owner[$Incoming::mode], $Incoming::location];

    if(%owner == "")
    {
        if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
            %owner = $Incoming[alternate, owner, $Incoming::owner[$Incoming::mode], $Incoming::location];
        else
            %owner = $Incoming[default, owner, $Incoming::owner[$Incoming::mode], $Incoming::location];
    }

    return %owner;
}


function Incoming::cell(%step, %n)
{
    if(%step == location)
    {
        %owner = $Incoming[$Incoming::mode, owner, $Incoming::owner[$Incoming::mode], %n];

        if(%owner == "")
        {
            if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
                %owner = $Incoming[alternate, owner, $Incoming::owner[$Incoming::mode], %n];
            else
                %owner = $Incoming[default, owner, $Incoming::owner[$Incoming::mode], %n];
        }
    }

    if(%n == numlock)
        %step = $Incoming::owner[$Incoming::mode];
    else if(%n == slash)
        %step = $Incoming::owner[$Incoming::mode];
    else if(%n == star)
        %step = $Incoming::owner[$Incoming::mode];

    %text = $Incoming[$Incoming::mode, %step, %n];

    if(%text == "")
    {
        if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
            %text = $Incoming[alternate, %step, %n];
        else
            %text = $Incoming[default, %step, %n];
    }

    return %owner @ %text;
}


function Incoming::hide()
{
    Control::setVisible("IncomingHEADERF", false);
    Control::setVisible("IncomingMIDDLEF", false);
    Control::setVisible("IncomingFRAME", false);
}


function Incoming::cleartext()
{
    $Incoming::text[type] =
    $Incoming::text[bearing] =
    $Incoming::text[location] =
    $Incoming::text[heading] = "";
}


function Incoming::nextStep()
{
    %step = $Incoming::nextStepFrom[$Incoming::mode, $Incoming::step];

    if(%step == "")
    {
        if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
            %step = $Incoming::nextStepFrom[alternate, $Incoming::step];
        else
            %step = $Incoming::nextStepFrom[default, $Incoming::step];
    }

    if(%step == "")
        return abort;

    return %step;
}

function Incoming::prevStep()
{
    %step = $Incoming::prevStepFrom[$Incoming::mode, $Incoming::step];

    if(%step == "")
    {
        if(($Incoming::mode == $Incoming::map) || ($Incoming::mode == alternate))
            %step = $Incoming::prevStepFrom[alternate, $Incoming::step];
        else
            %step = $Incoming::prevStepFrom[default, $Incoming::step];
    }

    if(%step == "")
        return type;

    return %step;
}


function IncomingFRAME::make()
{
    if($IncomingFRAME::exists)
        IncomingFRAME::remove();

    $IncomingHEADERF = newObject("IncomingHEADERF", FearGui::FearGuiMenu, $IncomingHEADER::x, $IncomingHEADER::y, $IncomingHUD::width, $IncomingHEADER::height);
    $IncomingHEADER = newObject("IncomingHEADER", FearGuiFormattedText, 0, 0, $IncomingHUD::width - 4, $IncomingHEADER::height + 1);
    addToSet(PlayGui, $IncomingHEADERF);
    addToSet($IncomingHEADERF, $IncomingHEADER);

    Control::setVisible("IncomingHEADERF", false);

    $IncomingMIDDLEF = newObject("IncomingMIDDLEF", FearGui::FearGuiMenu, $IncomingMIDDLE::x, $IncomingMIDDLE::y, $IncomingHUD::width, $IncomingMIDDLE::height);
    $IncomingMIDDLE = newObject("IncomingMIDDLE", FearGuiFormattedText, 0, 0, $IncomingHUD::width - 4, $IncomingMIDDLE::height + 1);
    addToSet(PlayGui, $IncomingMIDDLEF);
    addToSet($IncomingMIDDLEF, $IncomingMIDDLE);

    Control::setVisible("IncomingMIDDLEF", false);

    $IncomingFRAME = newObject("IncomingFRAME", FearGui::FearGuiMenu, $IncomingFRAME::x, $IncomingFRAME::y, $IncomingFRAME::width, $IncomingFRAME::height);
    addToSet(PlayGui, $IncomingFRAME);

    Control::setVisible("IncomingFRAME", false);

    $IncomingFRAME::exists = true;
}

function IncomingFRAME::remove()
{
    if($IncomingFRAME::exists)
    {
        deleteObject($IncomingFRAME);
        $IncomingFRAME::exists = false;

        deleteObject($IncomingHEADER);
        deleteObject($IncomingHEADERF);

        deleteObject($IncomingMIDDLE);
        deleteObject($IncomingMIDDLEF);
    }
}


function IncomingHUD::make(%n)
{
    if(%n == "")
    {
        incominghud::make(numlock);
        incominghud::make(slash);
        incominghud::make(star);

        for(%i = 1; %i < 10; %i++)
            incominghud::make(%i);

        return;
    }

    if($IncomingHUD::exists[%n])
        IncomingHUD::remove(%n);

    if(!$IncomingFRAME::exists)
        IncomingFRAME::make();


    $IncomingCELL[%n] = newObject("IncomingCELL" @ %n, SimGui::Control, $IncomingHUD::x[%n], $IncomingHUD::y[%n], $IncomingHUD::cellwidth, $IncomingHUD::cellheight);
    $IncomingHUD[%n] = newObject("IncomingHUD" @ %n, FearGuiFormattedText, 4, -1, $IncomingHUD::cellwidth - 4, $IncomingHUD::cellheight + 1);
    addToSet($IncomingFRAME, $IncomingCELL[%n]);
    addToSet($IncomingCELL[%n], $IncomingHUD[%n]);

    $IncomingHUD::exists[%n] = true;
}

function IncomingHUD::remove(%n)
{
    if(%n == "")
    {
        incominghud::remove(numlock);
        incominghud::remove(slash);
        incominghud::remove(star);

        for(%i = 1; %i < 10; %i++)
            IncomingHUD::remove(%i);

        IncomingFRAME::remove();
        return;
    }

    if($IncomingHUD::exists[%n])
    {
        deleteObject($IncomingHUD[%n]);
        deleteObject($IncomingCELL[%n]);
        $IncomingHUD::exists[%n] = false;
    }
}



function Incoming::bindKeys()
{
    newActionMap("IncomingMap.sae");

    bindCommand(keyboard0, make, "numpad+", TO, "Incoming::more();");
    bindCommand(keyboard0, make, "numpad-", TO, "Incoming::less();");
    bindCommand(keyboard0, make, "numpadenter", TO, "Incoming(star);");

    bindCommand(keyboard0, make, "numlock", TO, "Incoming(numlock);");
    bindCommand(keyboard0, make, "numpad/", TO, "Incoming(slash);");
    bindCommand(keyboard0, make, "numpad*", TO, "Incoming(star);");
    bindCommand(keyboard0, make, decimal, TO, "Incoming(decimal);");
    bindCommand(keyboard0, make, escape, TO, "Incoming(5);");
    bindCommand(keyboard0, make, numpad0, TO, "Incoming(owner);");

    if($Incoming::useCursorRightForSkip)
        bindCommand(keyboard0, make, right, TO, "Incoming(skip);");

    if($Incoming::usePageDownForSkip)
        bindCommand(keyboard0, make, next, TO, "Incoming(skip);");

    bindCommand(keyboard0, make, numpad1, TO, "Incoming(1);");
    bindCommand(keyboard0, make, numpad2, TO, "Incoming(2);");
    bindCommand(keyboard0, make, numpad3, TO, "Incoming(3);");
    bindCommand(keyboard0, make, numpad4, TO, "Incoming(4);");
    bindCommand(keyboard0, make, numpad5, TO, "Incoming(5);");
    bindCommand(keyboard0, make, numpad6, TO, "Incoming(6);");
    bindCommand(keyboard0, make, numpad7, TO, "Incoming(7);");
    bindCommand(keyboard0, make, numpad8, TO, "Incoming(8);");
    bindCommand(keyboard0, make, numpad9, TO, "Incoming(9);");

    bindCommand(keyboard0, make, control, numpad1, TO, "Incoming::setNumber(1);");
    bindCommand(keyboard0, make, control, numpad2, TO, "Incoming::setNumber(2);");
    bindCommand(keyboard0, make, control, numpad3, TO, "Incoming::setNumber(3);");
    bindCommand(keyboard0, make, control, numpad4, TO, "Incoming::setNumber(4);");
    bindCommand(keyboard0, make, control, numpad5, TO, "Incoming::setNumber(5);");
    bindCommand(keyboard0, make, control, numpad6, TO, "Incoming::setNumber(5);");
    bindCommand(keyboard0, make, control, numpad7, TO, "Incoming::setNumber(5);");
    bindCommand(keyboard0, make, control, numpad8, TO, "Incoming::setNumber(5);");
    bindCommand(keyboard0, make, control, numpad9, TO, "Incoming::setNumber(5);");

    bindCommand(keyboard0, make, alt, numpad1, TO, "Incoming::setNorth(1);");
    bindCommand(keyboard0, make, alt, numpad2, TO, "Incoming::setNorth(2);");
    bindCommand(keyboard0, make, alt, numpad3, TO, "Incoming::setNorth(3);");
    bindCommand(keyboard0, make, alt, numpad4, TO, "Incoming::setNorth(4);");
    bindCommand(keyboard0, make, alt, numpad6, TO, "Incoming::setNorth(6);");
    bindCommand(keyboard0, make, alt, numpad7, TO, "Incoming::setNorth(7);");
    bindCommand(keyboard0, make, alt, numpad8, TO, "Incoming::setNorth(8);");
    bindCommand(keyboard0, make, alt, numpad9, TO, "Incoming::setNorth(9);");

}


function Incoming::onMissionInfo(%server, %missionName, $ServerMissionType)
{
    echo();
    echo("Map = " @ %missionName);
    echo();
    echo("Setting north to numpad8");
    echo();
    Incoming::resetNorth();
    $Incoming::map = %missionName;
    return;
}


// Remove IncomingHUD before play.gui is saved on exit -- important!
//
Event::Attach(eventExit, "IncomingHUD::remove();");


function Incoming::setup()
{
    $IncomingHUD::cellwidth = 88;
    $IncomingHUD::cellheight = 44;

    $IncomingHUD::width = 3 * $IncomingHUD::cellwidth;

    $IncomingHEADER::width =
    $IncomingMIDDLE::width =
    $IncomingFRAME::width = $IncomingHUD::width;

    $IncomingHEADER::height = 44;
    $IncomingMIDDLE::height = 20;
    $IncomingFRAME::height = 4 * $IncomingHUD::cellheight;

    $IncomingHUD::height = $IncomingHEADER::height
                         + $IncomingMIDDLE::height
                         + $IncomingFRAME::height;

    $IncomingHEADER::x =
    $IncomingMIDDLE::x =
    $IncomingFRAME::x = whud::x($IncomingHUD::x, $IncomingHUD::width);

    $IncomingSIDE::x = $IncomingFRAME::x + $IncomingFRAME::width - 2;

    $IncomingHEADER::y = whud::y($IncomingHUD::y, $IncomingHUD::height);

    $IncomingMIDDLE::y = $IncomingHEADER::y + $IncomingHEADER::height - 1;

    $IncomingFRAME::y = $IncomingMIDDLE::y + $IncomingMIDDLE::height - 1;

    $IncomingHUD::x[numlock] = $IncomingHUD::x[7] = $IncomingHUD::x[4] = $IncomingHUD::x[1] = 0;
    $IncomingHUD::x[slash] = $IncomingHUD::x[8] = $IncomingHUD::x[5] = $IncomingHUD::x[2] = $IncomingHUD::cellwidth - 2;
    $IncomingHUD::x[star] = $IncomingHUD::x[9] = $IncomingHUD::x[6] = $IncomingHUD::x[3] = $IncomingHUD::x[slash] + $IncomingHUD::cellwidth - 2;

    $IncomingHUD::y[numlock] = $IncomingHUD::y[slash] = $IncomingHUD::y[star] = 0;
    $IncomingHUD::y[7] = $IncomingHUD::y[8] = $IncomingHUD::y[9] = $IncomingHUD::y[numlock] + $IncomingHUD::cellheight - 1;
    $IncomingHUD::y[4] = $IncomingHUD::y[5] = $IncomingHUD::y[6] = $IncomingHUD::y[7] + $IncomingHUD::cellheight - 1;
    $IncomingHUD::y[1] = $IncomingHUD::y[2] = $IncomingHUD::y[3] = $IncomingHUD::y[4] + $IncomingHUD::cellheight - 1;

    echo();
    echo("binding keys for writer\\incoming.cs");

    Incoming::bindKeys();

    echo("generating gui objects for writer\\incoming.cs");

    IncomingHUD::make();

    echo();
}


// Build IncomingHUD on first weapon switch, after playGui exists
function IncomingHUD::onYouSpawned()
{
    if(!$IncomingHUD::Exists)
        Incoming::setup();

    return;
}


function incoming::defaults()
{

    //$Incoming[Scarabrae, owner, 0, decimal] = "at our\n";
    //$Incoming[Scarabrae, owner, 0, 1] = "at our\n";
    $Incoming[Scarabrae, owner, 0, 2] = "on\n";
    //$Incoming[Scarabrae, owner, 0, 3] = "at\n";
    //$Incoming[Scarabrae, owner, 0, 4] = "attacking\n";
    //$Incoming[Scarabrae, owner, 0, 5] = "";
    //$Incoming[Scarabrae, owner, 0, 6] = "attacking\n";
    //$Incoming[Scarabrae, owner, 0, 7] = "on our\n";
    //$Incoming[Scarabrae, owner, 0, 8] = "attacking\n";
    //$Incoming[Scarabrae, owner, 0, 9] = "attacking\n";

    //$Incoming[Scarabrae, owner, 1, decimal] = "at enemy\n";
    //$Incoming[Scarabrae, owner, 1, 1] = "at enemy\n";
    $Incoming[Scarabrae, owner, 1, 2] = "on\n";
    //$Incoming[Scarabrae, owner, 1, 3] = "at\n";
    //$Incoming[Scarabrae, owner, 1, 4] = "defending\n";
    //$Incoming[Scarabrae, owner, 1, 5] = "";
    //$Incoming[Scarabrae, owner, 1, 6] = "defending\n";
    //$Incoming[Scarabrae, owner, 1, 7] = "on enemy\n";
    //$Incoming[Scarabrae, owner, 1, 8] = "defending\n";
    //$Incoming[Scarabrae, owner, 1, 9] = "defending\n";

    //$Incoming[Scarabrae, location, decimal] = "sensor";
    //$Incoming[Scarabrae, location, 1] = "front door";
    $Incoming[Scarabrae, location, 2] = "2nd floor";
    //$Incoming[Scarabrae, location, 3] = "objective";
    //$Incoming[Scarabrae, location, 4] = "generator";
    //$incoming[Scarabrae, location, 5] = "CANCEL";
    //$Incoming[Scarabrae, location, 6] = "turret";
    //$Incoming[Scarabrae, location, 7] = "roof";
    //$Incoming[Scarabrae, location, 8] = "base";
    //$Incoming[Scarabrae, location, 9] = "flag";

    $Incoming::sound[alternate, location, 0, 2] = "~wbasundr"; // The enemy is attacking our base!


    flushExportText();
    newObject(incomingSave, fearguiformattedtext,0,0,0,0);

    AddExportText("// ---------------------------------------------------------------------------");
    AddExportText("// incoming_data.cs -- Version 0.5 -- March 1, 2000");
    AddExportText("// by Lorne Laliberte (writer@planetstarsiege.com)");
    AddExportText("//");
    AddExportText("// http://www.writerscripts.com");
    AddExportText("// ---------------------------------------------------------------------------");
    AddExportText("");
    AddExportText("// See below for some sample map-specific strings.");
    AddExportText("");
    AddExportText("// Press the numlock key to switch between default and map-specific modes at");
    AddExportText("// any time while the incomingHUD is displayed.");
    AddExportText("");
    AddExportText("// This file is a slapped-together early beta!  If you want to help define the");
    AddExportText("// strings, I'd appreciate it.  Some level of consistency is probably a good");
    AddExportText("// idea, though, so keep that in mind as you think of how to improve this.");
    AddExportText("");
    AddExportText("");
    AddExportText("//$Incoming[Scarabrae, owner, 0, decimal] = \"at our\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 0, 1] = \"at our\\n\";");
    AddExportText("$Incoming[Scarabrae, owner, 0, 2] = \"on\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 0, 3] = \"at\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 0, 4] = \"attacking\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 0, 5] = \"\";");
    AddExportText("//$Incoming[Scarabrae, owner, 0, 6] = \"attacking\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 0, 7] = \"on our\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 0, 8] = \"attacking\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 0, 9] = \"attacking\\n\";");
    AddExportText("");
    AddExportText("//$Incoming[Scarabrae, owner, 1, decimal] = \"at enemy\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 1, 1] = \"at enemy\\n\";");
    AddExportText("$Incoming[Scarabrae, owner, 1, 2] = \"on\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 1, 3] = \"at\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 1, 4] = \"defending\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 1, 5] = \"\";");
    AddExportText("//$Incoming[Scarabrae, owner, 1, 6] = \"defending\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 1, 7] = \"on enemy\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 1, 8] = \"defending\\n\";");
    AddExportText("//$Incoming[Scarabrae, owner, 1, 9] = \"defending\\n\";");
    AddExportText("");
    AddExportText("//$Incoming[Scarabrae, location, decimal] = \"sensor\";");
    AddExportText("//$Incoming[Scarabrae, location, 1] = \"front door\";");
    AddExportText("$Incoming[Scarabrae, location, 2] = \"2nd floor\";");
    AddExportText("//$Incoming[Scarabrae, location, 3] = \"objective\";");
    AddExportText("//$Incoming[Scarabrae, location, 4] = \"generator\";");
    AddExportText("//$incoming[Scarabrae, location, 5] = \"CANCEL\";");
    AddExportText("//$Incoming[Scarabrae, location, 6] = \"turret\";");
    AddExportText("//$Incoming[Scarabrae, location, 7] = \"roof\";");
    AddExportText("//$Incoming[Scarabrae, location, 8] = \"base\";");
    AddExportText("//$Incoming[Scarabrae, location, 9] = \"flag\";");
    AddExportText("");
    AddExportText("$Incoming::sound[alternate, location, 0, 2] = \"~wbasundr\"; // The enemy is attacking our base!");
    AddExportText("");

    AddExportText("// Remove the incomingSave object that gets created whenever this file is executed");
    AddExportText("if(isObject(incomingSave))");
    AddExportText("    deleteobject(incomingSave);");

    exportObjectToScript(incomingSave, "config\\incoming_data.cs", true);
    deleteobject(incomingSave);
    flushExportText();

    echo();
    echo("default config\\incoming_data.cs created!");
    echo();
}

function incoming::save()
{
    AddExportText("    // x and y coordinates for the IncomingHUD interface");
    ExportSetting("    $IncomingHUD::x", "100%");
    ExportSetting("    $IncomingHUD::y", "50%");
    AddExportText("");
    AddExportText("    // Use the Cursor Right key to skip either the bearing or the location step");
    AddExportText("    // while IncomingHUD is displayed -- does not affect the use of this key");
    AddExportText("    // while the hud isn't displayed");
    ExportSetting("    $Incoming::useCursorRightForSkip", false);
    AddExportText("");
    AddExportText("    // Use the Page Down key to skip either the bearing or the location step");
    AddExportText("    // while IncomingHUD is displayed -- does not affect the use of this key");
    AddExportText("    // while the hud isn't displayed");
    ExportSetting("    $Incoming::usePageDownForSkip", true);
    AddExportText("");
    AddExportText("    // Access the Incoming HUD -- default mode");

    ExportBind("Incoming();", "//bind(keyboard0, make, \"numpad*\", TO, \"Incoming();\");");

    AddExportText("");
    AddExportText("    // Access the Incoming HUD -- alternate mode");

    ExportBind("Incoming(alternate);", "//bind(keyboard0, make, \"numlock\", TO, \"Incoming(alternate);\");");

    AddExportText("");
    AddExportText("    // Access the Incoming HUD -- map-specific mode");

    ExportBind("Incoming(map);", "//bind(keyboard0, make, \"numpad/\", TO, \"Incoming(map);\");");

    AddExportText("");
    AddExportText("    // Access the Incoming HUD -- inbound mode");

    ExportBind("Incoming(inbound);", "//bind(keyboard0, make, \"numpad-\", TO, \"Incoming(inbound);\");");

    AddExportText("");
    AddExportText("    // Access the Incoming HUD -- outbound mode");

    ExportBind("Incoming(outbound);", "//bind(keyboard0, make, \"numpad+\", TO, \"Incoming(outbound);\");");
}

WriterPrefs::save("incoming");

function incoming::init()
{
    needs("writer\\incoming.cs", "writer\\event.cs 2.7",
                                 "writer\\save.cs 2.3",
                                 "writer\\schedule.cs 1.3",
                                 "writer\\screensize.cs 1.1",
                                 "writer\\whatif.cs 1.1",
                                 "writer\\whud.cs 1.2");

    if(isFile("config\\incoming_data.cs"))
        exec("incoming_data.cs"); // Go get the map-specific data
    else
        incoming::defaults(); // create default incoming_data.cs file and set default values

    Event::Attach(eventYouSpawned, "IncomingHUD::onYouSpawned();");
    Event::Attach(eventMissionInfo, Incoming::onMissionInfo);
    Event::Attach(eventScreenModeChanged, "IncomingHUD::remove();Incoming::setup();");
}
Event::Attach(writerInit, "incoming::init();");

if(!$UsingWriterLoader) incoming::init();
